
var map;


$(document).ready(function(){   
	
				
				

				if ($('#selTerminal').val()=='NULL')
				{
					$('#ContenedorMap').hide();
					$('#locOptions').hide();
				}
				
				else
				{	
						//los campos date1 y date2 son fechas, por lo que les asignamos un generador automático de fechas
						//empleamos Zeta-DatePicker: http://stefangabos.ro/jquery/zebra-datepicker/	
				
						$('#date1').Zebra_DatePicker({
		  					direction:[false,7],
		  					pair: $('#date2'),		  					
		  					format: 'Ymd',
		  					
		  							  					
						});
					
			
						$('#date2').Zebra_DatePicker({
								direction: true,
		  					format: 'Ymd'
		  					
						});
				
						
						//La primera opción que aparece por defecto en locOptionsType es "Mostrar última posición conocida", 
						//por lo que no es preciso mostrar la opciones de rango de fechas
						
						$('#locOptionsRange').hide();
		
					
						//asignamos las funciones a cada elemento:
						
						$('#selTerminal').change(function() { 
							$('#locOptionError').html(""); 							
							$('#locOptionsMode').val('last');
							$('#locOptionsRange').hide();								
							DeletePoints();
							
							
						});
						
					
						
				
						$('#locOptionsMode').change(function() { 	
							$('#locOptionError').html(""); 
							if ($('#locOptionsMode').val()=='last')
							{
								$('#locOptionsRange').hide();											
								
							}
							else
							{
								$('#locOptionsRange').show();
								
							}
							DeletePoints();
							
						});
						
						$('#locOptionsButton').click(function() {
									getLocations();
						});
						
												
				     map= new GMaps({
			  							div: '#map',
			  							lat: 37.388628,
			  							lng: -5.995593
											});
											
						
				}							
								
	     	
});
	                               
function getLocations( ){
			
					DeletePoints();//Eliminamos los puntos del mapa representados anteriormente
	
					
					$('#locOptionError').html(""); 
					
					var device=$('#selTerminal').val().split(';');
					
					
					
					if (($('#locOptionsMode').val()=='last')|| ($('#locOptionsMode').val()=='date' && $('#date1').val()!="" && $('#date2').val()!="" && $('#date1').val()<= $('#date2').val()))
						{
										$.ajax({
						         type: "POST",
						         url: "main_response.php",
						         data: "deviceid="+ device[0] + "&imei=" + device[1] + "&mode=" + $('#locOptionsMode').val() + "&date1=" + $('#date1').val() + "&date2=" + $('#date2').val() ,
						         dataType: "xml",
						         success: function(xml){
						         				
						      					var error=0;
						      					var locations=0;
						      					var primerPunto=1;
						      					var i=1;
						      				
						      			
						          			//Buscamos si hay algun error
						      					$(xml).find('Error').each(function () {
						      						$('#locOptionError').html($(this).attr('desc'));      						
						      						error=1;
						      					});
						      					//si no hay errores procedemos a incluir los nuevos puntos
						      					if (!error)
						      					{
						      						$(xml).find('location').each(function () {
						      							locations=1;
						      							insertPoint(i,
												      							$(this).attr('imei'),
																			  		$(this).attr('phonenumber'),
																			  		$(this).attr('time'),
																			  		$(this).attr('time2'),
																			  		$(this).attr('lat'),
																			  		$(this).attr('lng'),
																			  		$(this).attr('alt'),
																			  		$(this).attr('spd'),
																			  		$(this).attr('acc'),
																			  		$(this).attr('source')
																			  		
																	      );  
						      							i++;
						      									
						      						});
						       					
						       						if (!locations)
						       						{
						       								$('#locOptionError').html("No se han encontrado puntos para el periodo indicado");
						       						}
						       					
						       					}
						         
						         			},
						         error: function() {
										    alert("An error occurred while processing XML file.");
										 }
					   			});
						}
					else
						{
							$('#locOptionError').html("ERROR: faltan parametros");
						}
					
	}


function insertPoint (index,imei,phonenumber,time,time2,lat,lng,alt,spd,acc,source){
	
	$('#Puntos').append('<label id="marker_'+index+'"># '+time+'</label><br>');
	
	$('#marker_'+index).click(function(){
			map.setCenter(lat,lng);
	});
	
	
	var latVal=parseFloat(lat.replace(",","."));
	var lngVal=parseFloat(lng.replace(",","."));
	var accVal=parseFloat(acc.replace(",","."));


	if (index==1)
		{
			map.addMarker({
					  lat: lat,
					  lng: lng,
					  title: time,
					  infoWindow: {
		  					content:'<p><b>IMEI: </b>'+imei+'</p>'
						  					+'<p><b>Número de teléfono: </b>'+phonenumber+'</p>'
						  					+'<p><b>Dia-Hora de la localización: </b>'+time+'</p>'
						  					//+'<p><b>Dia-Hora en que se ha recibido en el servidor: </b>'+time2+'</p>'
						  					+'<p><b>Fuente con la que se ha obtenido la localización: </b>'+source+'</p>'
						  					+'<p><b>Latitud: </b>'+lat+'</p>'
						  					+'<p><b>Longitud: </b>'+lng+'</p>'
						  					+'<p><b>Altitud: </b>'+alt+'</p>'
						  					+'<p><b>Velocidad: </b>'+spd+'</p>'
						  					+'<p><b>Precisión (metros): </b>'+Math.round(accVal)+'</p>'
						  }
						  
					});
					
			//añadimos ahora un circulo que representa la precisión del punto:
			
				map.drawCircle({
					  lat: latVal,
					  lng: lngVal,
					  radius: accVal,  // meters
					  strokeColor: '#FF0000',
					  strokeOpacity: 0.7,
					  strokeWeight: 1,
					  fillColor: '#FF0000',
					  fillOpacity: 0.05
					});
					
					
					
					
				map.setCenter(lat,lng);
		}
	else
		{
				map.addMarker({
					  lat: lat,
					  lng: lng,
					  title: time,
					  icon  : 'images/blue_icon.png',
					  infoWindow: {
		  				content:'<p><b>IMEI: </b>'+imei+'</p>'
						  					+'<p><b>Número de teléfono: </b>'+phonenumber+'</p>'
						  					+'<p><b>Dia-Hora de la localización: </b>'+time+'</p>'
						  					//+'<p><b>Dia-Hora en que se ha recibido en el servidor: </b>'+time2+'</p>'
						  					+'<p><b>Fuente con la que se ha obtenido la localización: </b>'+source+'</p>'
						  					+'<p><b>Latitud: </b>'+lat+'</p>'
						  					+'<p><b>Longitud: </b>'+lng+'</p>'
						  					+'<p><b>Altitud: </b>'+alt+'</p>'
						  					+'<p><b>Velocidad: </b>'+spd+'</p>'
						  					+'<p><b>Precisión (metros): </b>'+Math.round(accVal)+'</p>'
						  }
					  
					});
					
					
					/*
					map.drawCircle({
						lat: latVal,
						lng: lngVal,
						radius: accVal,  // meters
						strokeColor: '#000080',
					    strokeOpacity: 0.4,
    					strokeWeight: 1
						});
					*/
					
				
		}
	
}

function DeletePoints(){
	
	$('#Puntos').html(""); //Vaciamos la lista de puntos anterior
	map.removeMarkers();
	map.removePolygons();
	
}
