<?php

/*MODIFICADO DE :   https://developers.google.com/maps/articles/phpsqlajax_v3?hl=es  */

//  	http://localhost/pfc/locations2.php?imei=34567567890&mode=last&date1=&date2=


function parseToXML($htmlStr) 
{ 
$xmlStr=str_replace('<','&lt;',$htmlStr); 
$xmlStr=str_replace('>','&gt;',$xmlStr); 
$xmlStr=str_replace('"','&quot;',$xmlStr); 
$xmlStr=str_replace("'",'&#39;',$xmlStr); 
$xmlStr=str_replace("&",'&amp;',$xmlStr); 
return $xmlStr; 
} 

include ("conexion.php");

session_start();

header("Content-type: text/xml");

if (!isset($_SESSION['user']))
{
	echo '<Errors><Error desc="Error: No ha iniciado sesion"/></Errors>';
	goto fin;
}


if(!(isset($_POST['deviceid'])AND isset($_POST	['imei']) AND isset($_POST['mode'])AND isset($_POST['date1'])AND isset($_POST['date2'])))
{
		echo '<Errors><Error desc="Error: No ha indicado todos los parametros"/></Errors>';
		goto fin;
}

if($_POST	['imei']=="" || $_POST	['deviceid']=="")
{
			echo '<Errors><Error desc="Error: No ha indicado todos los parametros"/></Errors>';
			goto fin;
}

	
		//Verificamos si el imei solicitado pertenece al usuario
		
		$conexion = @mysqli_connect($nombre_server,$nombre_user,$password) or exit('3');
		mysqli_select_db($conexion,$nombre_db) or exit('4');
		$query = "SELECT * FROM relations WHERE deviceid='".$_POST['deviceid']."' and imei='".$_POST['imei']."' and user='".$_SESSION['user']."'";		
		$result = mysqli_query($conexion,$query);	
		if(mysqli_num_rows($result)==0)
		{
						echo '<Errors><Error desc="Error: No esta autorizado a ver este terminal"/></Errors>';
						goto fin;
		}
		
		
		//Obtenemos las posiciones solicitadas segun los parámetros remitidos:
		
				
		if ($_POST['mode']=='last') //Se ha pedido solo la última posicion
		{	
			
				$sql="Select * from locations where imei='".$_POST['imei']."' and deviceid='".$_POST['deviceid']."' order by ts DESC limit 1";
		}
		else //Se ha solicitado un rango de fecha
		{	
				if($_POST['date1']=="" || $_POST['date2']=="" || $_POST['date1']>$_POST['date2'])
				{
					echo '<Errors><Error desc="Error: Rango de fechas erroneo"/></Errors>';
					goto fin;
				}
				else
				{					
						$sql=	"Select * from locations where imei='".$_POST['imei']."' and deviceid='".$_POST['deviceid']."' and date(ts)>='".$_POST['date1']."' and date(ts)<='".$_POST['date2']."' order by ts DESC";
				}
		}
		
		//ejecutamos la consulta:
			
			$result = mysqli_query($conexion,$sql) or exit ('5');	
			if(mysqli_num_rows($result)==0)
			{
				echo '<Errors><Error desc="Error: No hay localizaciones para la opcion seleccionada"/></Errors>';
				goto fin;
			}
			
			
			//Montamos el xml:			
			
				echo '<locations>';

				while ($row = @mysqli_fetch_assoc($result)){
				  // ADD TO XML DOCUMENT NODE
				  echo '<location ';
				  echo 'imei="' . parseToXML($row['imei']) . '" ';
				  echo 'phonenumber="' . parseToXML($row['phonenumber']) . '" ';
				  echo 'time="' . parseToXML($row['ts_location']) . '" ';
				  echo 'time2="' . parseToXML($row['ts']) . '" ';
				  echo 'lat="' . $row['lat'] . '" ';
				  echo 'lng="' . $row['lng'] . '" ';
				  echo 'alt="' . $row['alt'] . '" ';
				  echo 'spd="' . $row['spd'] . '" ';
				  echo 'acc="' . $row['acc'] . '" ';
			
				 
				  //verificamos si la posición se ha detectado desde la última comunicación con el servidor:
				  
				  	if ($row['source']=="GPS_REAL" ||$row['source']=="GPS_LAST")
						{ 
								echo 'source="GPS"';
						}
						else
						{
								echo 'source="NETWORK"';
						}
				  
				  echo '/>';
				}
				echo '</locations>';

			
		mysqli_free_result($result);
 
fin:

?>
